#!/usr/bin/env perl -w
#! Perl -w
use strict;
use warnings;

# This program takes the gene_association.goa_human file in GAF2.0 format downloaded from the GOA website and filters out DFLAT annotation
# Output: gene_association_noDFLAT.goa_human - contains all annotation except for DFLAT
# Output: DFLATonly.goa_human - contains all removed DFLAT annotation

my $goa = "Input_Annotations/gene_association.goa_human";
my @newgoa;
my $goa_counter = 0;
my $dflat_counter = 0;
my $newgoa_counter = 0;
my @rejectedgoa;


unless (open(FILE, $goa)) {
    die "Couldn't open $goa\n";
}
while (my $line = <FILE>) {
	$goa_counter++;
	chomp $line;
	my @splitline = split (/\t/, $line);
	if ($splitline[14] eq "DFLAT") {
		push @rejectedgoa, $line;
#		print "$line\n";
		$dflat_counter++;
	} else {
		push @newgoa, $line;
		$newgoa_counter++;
	}
}

print "Original GOA: $goa_counter\nDFLAT removed: $dflat_counter\nNew GOA: $newgoa_counter\n";

unless (open(FILE, ">Output/gene_association_noDFLAT.goa_human")) {
    die "Couldn't open noDFLAT file to write!\n"
}
foreach (@newgoa) {
    print FILE "$_\n";
}
close(FILE);

unless (open(FILE, ">Output/DFLATonly.goa_human")) {
    die "Couldn't open Rejected file to write!\n"
}
foreach (@rejectedgoa) {
    print FILE "$_\n";
}
close(FILE);
