import sys
import csv
import urllib,urllib2

def main():
	# make sure that the file is updated
	inputfile = "Input_Mappings/Human_SP_IDs.txt"
	outputfile = "Input_Mappings/MGImouseUP.txt"

	# read the input file and collect MGI ids
	mgis = []
	with open(inputfile, 'r') as fi:
		# skip the first line
		fi.readline()
		for tokens in csv.reader(fi, delimiter='\t'):
			if len(tokens) > 2 and tokens[2] != "":
				mgis.append(tokens[2])

	# remove duplicates
	mgis = list(set(mgis))

        url = 'http://www.uniprot.org/mapping/'

        # find alternative uniprot accessions if query accessions are obsolete
        params = {
        'from':'MGI_ID',
        'to':'ACC',
        'format':'tab',
        'query':' '.join(mgis)
        }
        
        data = urllib.urlencode(params)
        request = urllib2.Request(url, data)
        contact = "" # Please set your email address here to help us debug in case of problems.
        request.add_header('User-Agent', 'Python %s' % contact)
        response = urllib2.urlopen(request)

	# write the results to a file
	with open(outputfile, 'w') as fo:
		for line in response:
			fo.write(line)


if __name__ == "__main__":
    main()
